import java.util.concurrent.CyclicBarrier;

public class Main {

    public static void main(String[] argv) {
        CyclicBarrier barrier = new CyclicBarrier(2);
        CyclicBarrier meet    = new CyclicBarrier(2, new Meet());

        Thread s = new Thread(new Bill(barrier, meet));
        Thread t = new Thread(new Ben(barrier, meet));

        s.start();
        t.start();

        try {
            s.join();
        } catch (InterruptedException ex) {
        }
        try {
            t.join();
        } catch (InterruptedException ex) {
        }
    }
}
