import java.util.concurrent.BrokenBarrierException;
import java.util.concurrent.CyclicBarrier;
import java.util.Random;

public class Maker implements Runnable {

    private CyclicBarrier waitForIt;
    private CyclicBarrier ready;
    private Random        generator = new Random();

    public Maker(CyclicBarrier waitForIt, CyclicBarrier ready) {
        this.waitForIt = waitForIt;
        this.ready      = ready;
    }

    public void run() {
        try {
            waitForIt.await(); 
        } catch (InterruptedException ex) { 
        } catch (BrokenBarrierException ex) { 
        }

        while (true) {
            try {
                Thread.sleep(generator.nextInt(30)+1);
            } catch (InterruptedException ex) { 
            }

            make();

            try {
                ready.await();
            } catch (InterruptedException ex) { 
            } catch (BrokenBarrierException ex) { 
            }
        }
    }

    public void make() {
        synchronized (System.out) {
            System.out.println("Make!");
        }
    }

}
