import java.util.concurrent.CyclicBarrier;

public class Main {

    public static void main(String[] argv) {
        CyclicBarrier barrier = new CyclicBarrier(2);
        CyclicBarrier ready   = new CyclicBarrier(2, new Ready());
        CyclicBarrier used    = new CyclicBarrier(2, new Used());

        Thread s = new Thread(new Maker(barrier, ready, used));
        Thread t = new Thread(new User(barrier, ready, used));

        s.start();
        t.start();

    }
}
